﻿////////////////////////////////////////////////////////////////////////////////
//
//  THIS CODE IS NOT APPROVED FOR USE IN/ON ANY OTHER UI ELEMENT OR PRODUCT COMPONENT.
//  Copyright (c) 2007 David E. Craig.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

/*
DESCRIPTION
===========
The CORE.JS file contains a set of core functions that are
not specificlly related to any one form.

NOTE: External dependencies should be avoided if at all 
      possible.
*/

// constants
var APP_NAME = "Clip Collector";
var APP_NAME_INSTALL = "ClipCollector.gadget";
var NAMESPACE = "Microsoft";
var SIDEBAR = "windows sidebar";
var DEFAULT_FLYOUT = "../html/flyout.html";
var VERSION = "2.0.0.0";
var UPDATE_URL = "http://www.kryl.com/bin/ClipCollector.php";
var DL_URL = "http://gallery.live.com/liveItemDetail.aspx?li=973e928c-19e2-4bd0-a292-817674273d4b";

/*============================================================
FUNCTION:   changeButton ( string , string )
PARAMETERS: n (string) id of img element
            s (string) path to an image
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 04/27/2007
DESCRIPTION:
Changee the image elements src to the specified string
==============================================================*/
function changeButton(o, p)
{
    if(o.disabled=="")
        o.src=p;
}

/*============================================================
FUNCTION:   disableButton ( object )
PARAMETERS: o (object) an image (button)
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 04/27/2007
DESCRIPTION:
Disabled the image control - button.
==============================================================*/
function disableButton(o)
{
    o.disabled = "disabled";
    o.src = "../images/button-" + o.alt + "-disabled.png";
}

/*============================================================
FUNCTION:   enableButton ( object )
PARAMETERS: o (object) an image (button)
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 04/27/2007
DESCRIPTION:
Enabled the image control - button.
==============================================================*/
function enableButton(o)
{
    o.disabled = "";
    o.src = "../images/button-" + o.alt + "-default.png";
}

/*============================================================
FUNCTION:   setFocus ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 04/27/2007
DESCRIPTION:
Sets focus so the controls on the form are active.
==============================================================*/
function setFocus()
{
    setTimeout(getFocus, 300);
}

/*============================================================
FUNCTION:   getFocus ( )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 04/27/2007
DESCRIPTION:
Called by setFocus
==============================================================*/
function getFocus() 
{
    self.focus();
}

/*============================================================
FUNCTION:   initEvents ( object )
PARAMETERS: o (object) a document element
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 04/27/2007
MODIFIED: 05/08/2007
DESCRIPTION:
Loop through the IMG elements in the document and all those
that are using the IMG-BUTTON class, add events to them so
that the following events make them dynamic buttons:
- onmouseover
- onmouseout
- onmousedown
- onmouseup
==============================================================*/
function initEvents(o)
{
    // get all th image elemets
    var imgs=o.getElementsByTagName("img");
    
    // loop though the images
    try {
        for(i=0;i<imgs.length;i++)
        {
            // if they are from the specified class
            if(imgs[i].className=="image-button")
            {
                // build the image paths...
                var a = imgs[i].alt;
                
                var std = "../images/button-" + a + "-default.png";
                var hvr = "../images/button-" + a + "-hover.png";
                var dwn = "../images/button-" + a + "-click.png";
                
                // apply the events
                imgs[i].onmouseover= new Function("changeButton(this,'" + hvr + "')");
                imgs[i].onmouseout= new Function("changeButton(this,'" + std + "')");
                imgs[i].onmousedown= new Function("changeButton(this,'" + dwn + "')");
                imgs[i].onmouseup= new Function("changeButton(this,'" + hvr + "')");
            }
        }
    } catch (err) {  }
}

/*============================================================
FUNCTION:   getFSO( )
DESCRIPTION:
Gets reference to an File System Object
==============================================================*/
function getFSO()
{
    try {
        var fso = new ActiveXObject("Scripting.FileSystemObject");
    } catch (err) { 
        return null;
    }
    
    return fso;
}

/*============================================================
FUNCTION:   corePath( )
DESCRIPTION:
Creates (if not exists) then returns the core path
==============================================================*/
function corePath()
{
    var retVal = new String();
    // get a File System Object reference
    var fso = getFSO();
    if (fso == null ) return "";
    // connect to the AppData folder
    var retVal = System.Environment.getEnvironmentVariable("APPDATA") 
    retVal += "\\" + NAMESPACE + "\\" + SIDEBAR;
    // verify that each folder exists - one step at a time
    if (fso.folderExists(retVal)==false)
        fso.CreateFolder(retVal);
    retVal+="\\"+APP_NAME_INSTALL;
    if (fso.folderExists(retVal)==false)
        fso.CreateFolder(retVal);
    // return the result
    return retVal;
}

/*============================================================
FUNCTION:   getClip( )
DESCRIPTION:
Reads a saved clip from disk
==============================================================*/
function getClip(n)
{
    try {
        var path = corePath() + "\\clip_" + n;
        var retVal="";
        
        var fso=getFSO();
        if(fso.FileExists(path))
        {
            var fil=fso.OpenTextFile(path);
            retVal=fil.ReadAll();
            fil.Close();
        }
    } catch (ex) {
        // do nothing
    }
    return retVal;
}

/*============================================================
FUNCTION:   saveClip( )
DESCRIPTION:
Saves a specified clip to disk
==============================================================*/
function saveClip(n, v)
{
    var path = corePath() + "\\clip_" + n;
    var fso = getFSO();
    
    if(fso.FileExists(path))
    {
        fso.DeleteFile(path);
    }
    
    var fil = fso.CreateTextFile(path);
    fil.Write(v);
    fil.close();
}

/*============================================================
FUNCTION:   deleteAllClips( )
DESCRIPTION:
Removed all the saved clip files
==============================================================*/
function deleteAllClips(n)
{
    for(i=1;i<=n;i++)
    {
        var path = corePath() + "\\clip_" + i;
        var fso = getFSO();
        
        if(fso.FileExists(path))
        {
            fso.DeleteFile(path);
        }
    }
}

/*============================================================
FUNCTION:   saveAllClips( )
DESCRIPTION:
Saves all the clips in memory to disk.
==============================================================*/
function saveAllClips()
{
    var clipCnt = System.Gadget.document.parentWindow.clipCnt;

    // resave them all
    for(i=1;i<=clipCnt;i++)
    {
       saveClip(i, System.Gadget.document.parentWindow.clips[i]);
    }
}


/*============================================================
FUNCTION:   getSetting( )
DESCRIPTION:
Reads the setting given
==============================================================*/
function getSetting(s)
{
    var path = corePath() + "\\" + s;
    var retVal="";
    
    var fso=getFSO();
    if(fso.FileExists(path))
    {
        var fil=fso.OpenTextFile(path);
        retVal=fil.ReadLine();
        fil.Close();
    }
    
    return retVal;
}

/*============================================================
FUNCTION:   saveSetting( )
DESCRIPTION:
Saves the setting given
==============================================================*/
function saveSetting(s, v)
{
    var path = corePath() + "\\" + s;
    var fso = getFSO();
    
    if(fso.FileExists(path))
    {
        fso.DeleteFile(path);
    }
    
    var fil = fso.CreateTextFile(path);
    fil.WriteLine(v);
    fil.close();
}

/*============================================================
FUNCTION:   checkForUpdate( )
DESCRIPTION:
Looks to see if there is an update available 
==============================================================*/
function checkForUpdate()
{
    // check for update
    var sURL = UPDATE_URL + "?ver=" + VERSION;
    try {
		var myAjax = new Ajax.Request(
			sURL, 
			{
				method: 'get', 
				onComplete: parseUpdateResponse
			}); 
	} catch (ex) {
	    // do nothing
    }
}

/*============================================================
FUNCTION:   parseUpdateResponse( )
DESCRIPTION:
Parses th AJAX response to see if there is indeed an update
==============================================================*/
function parseUpdateResponse(originalRequest)
{
    var sVer = new String(originalRequest.responseText);
    if(sVer=="UPDATE")
    {
        updateLink.href = DL_URL;
        updateLink.style.visibility = ""; 
    }
}