﻿////////////////////////////////////////////////////////////////////////////////
//
//  THIS CODE IS NOT APPROVED FOR USE IN/ON ANY OTHER UI ELEMENT OR PRODUCT COMPONENT.
//  Copyright (c) 2007 David E. Craig.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

/*
DESCRIPTION
===========
The MAIN.JS file contains a set of core functions that are
specificlly related to the main.html file.

NOTE: External dependencies should be avoided if at all 
      possible.
*/

// SETUP
System.Gadget.settingsUI="../html/settings.html";
System.Gadget.Flyout.file="../html/flyout.html";
System.Gadget.onSettingsClosed = initialize;

// GLOBALS
var currentClip = new String();
var previousClip = new String();
var clips = new Array();
var clipCnt = 0;
var CLIP_MAX = 15;

/*============================================================
FUNCTION:   setupGadget (  )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 05/08/2007
DESCRIPTION:
Arranges th controls on the form and initializes the form
level events for all items.
==============================================================*/
function setupGadget()
{
   initEvents(document.body);
    
   with (mainTable.style)
    {
        top="34px";
        left="22px";
    }
    
    initialize();
}

/*============================================================
FUNCTION:   initialize (  )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 05/08/2007
DESCRIPTION:
Load the settings and start the main loop.
==============================================================*/
function initialize()
{
    if(getSetting("v2Load")=="")
    {
        saveSetting("Save","True");
        saveSetting("v2Load","Yes");
    }
    loadSettings();
    if(getSetting("Save")=="True")
        loadAllClips();
    window.setTimeout("mainLoop()",1000);
}

/*============================================================
FUNCTION:   loadSettings (  )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 05/08/2007
DESCRIPTION:
Load the settings
==============================================================*/
function loadSettings()
{
    CLIP_MAX = Number(getSetting("Max"));
    if(CLIP_MAX==0)
        CLIP_MAX=15;
}

/*============================================================
FUNCTION:   mainLoop (  )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 05/08/2007
DESCRIPTION:
This is the core function for the gadget. Every 100ms this
event will fire. It will look at the clipboard and then
compare the data just pulled from the last data pulled. If
it is different, it will add it to the list of collected clips.

Aditionally, this loop serves to determine which buttons are
enabled and disabled, based on the status of clip count.
==============================================================*/
function mainLoop()
{
    try {
        currentClip = window.clipboardData.getData("Text");
     } catch (ex) { }
     
    if(currentClip==null) 
    {
        // reset the main loop timer
        window.setTimeout("mainLoop()",100);
        return;
    }
    
    try {
        // make sure that:
        // 1) that it is different from the last thing
        //    on the clipboard
        // 2) and that it is not something already in 
        //    the collection of clips (findItemInArray)
        if(currentClip != previousClip && 
           findItemInArray(clips,currentClip)==-1)
        {  
            // if we are at the MAX clip size
            // then delete the first clip and leave
            // space for the last item...
            if(clipCnt == CLIP_MAX)
            {
                for(i=0;i<CLIP_MAX;i++)
                    clips[i]==clips[i+1];
                clipCnt--; // so we can add to the end
            }
            
            clipCnt++;
            // set the current clip
            previousClip = currentClip;
            // add current clip to the clips collection
            clips[clipCnt] = currentClip;
            // save the clip...
            if(getSetting("Save")=="True")
            {
                saveClip(clipCnt, currentClip);
                saveSetting("ClipCnt", clipCnt);
            }
        } 
        else
        {
            currentClip=previousClip;
        }
    } catch (err) { }
    
    // update the display counter
    counter.innerText=clipCnt + " of " + CLIP_MAX;

    // reset the main loop timer
    window.setTimeout("mainLoop()",100);
    
}

/*============================================================
FUNCTION:   loadAllClips (  )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 12/10/2007
DESCRIPTION:
Loads all the clips saved to disk into memory
==============================================================*/
function loadAllClips()
{
    var badClips = new Number(0);
    clipCnt = Number(getSetting("ClipCnt"));
    
    for(i=1;i<=clipCnt;i++)
    {
        clips[i] = getClip(i);
        if(clips[i]==null || clips[i]=="")
            badClips++;
        else
            previousClip = currentClip = clips[i];
    }
    
    clipCnt-=badClips;
    counter.innerText=clipCnt + " of " + CLIP_MAX;
}

/*============================================================
FUNCTION:   mainTable_onclick (  )
PARAMETERS: N/A
RETURNS:    N/A
CREATED BY: David E. Craig
CREATED ON: 05/08/2007
DESCRIPTION:
The user clicked on a displayed clip. Load that one to the
clipboard, but set the previous and current values to the
new value so we avoid reloading it in the main loop
==============================================================*/
function mainTable_onclick()
{
    System.Gadget.Flyout.show=true;
}
